/*
 *  es3.c
 *  EsCode
 *
 *  Created by Emanuela Fachini on 23/04/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "opCoda.h"

int vocaleFine(char *s);
/*prec: s!= NULL
postc: restituisce 1 se l'ultimo carattere della stringa in input e' una vocale, 0 altrimenti*/

char* leggi();
/*postc: restituisce una stringa ottenuta da input*/

void leggiScrivi() 
/* 
 * legge una sequenza di NUM_MAX stringhe e stampa prima quelle che
 * terminano per vocale e poi le altre, mantenendo l'ordine
 * in cui sono state lette
 * si suppone che le stringhe siano scritte una per riga
 */
{CodaP finVoc = costrCoda(MAXNUM);
CodaP altre = costrCoda(MAXNUM);
int i=1;
char* s;
assert(finVoc);
assert(altre);
while (i <= MAXNUM)
	{i++;
         s=leggi()
        if (vocaleFine(s)) accoda(s,finVoc); else accoda(s,altre);
	}
printf("la sequenza delle stringhe che terminano per vocale e'\n");
while (!vuota(finVoc))
	{app = estrae(finVoc);
	printf("%s\n",app);
	}
printf("la sequenza delle stringhe che non terminano per vocale e'\n");
while (!vuota(altre))
	{app = estrae(altre);
	printf("%s\n",app);
	}
distrCoda(finVoc);
distrCoda(altre);
}

char * leggi()
/*postc: restituisce una stringa ottenuta da input*/
{int l;
char* s,*app = malloc(LUNGMAX*sizeof(char)); /*LUNGMAX e' una costante predefinita*/
printf("inserisci una  stringa, successiva in ordine alfabetico alla precedente \n");
	assert(scanf("%s",app));
	l = strlen(app);
	s = malloc((l+1)*sizeof(char));
	s= strcpy(s,app);
	printf("la stringa inserita e' %s\n", s);
return s;}
	

int vocaleFine(char *s)
/*prec: s!= NULL
postc: restituisce 1 se l'ultimo carattere della stringa in input e' una vocale*/
{ int i = strlen(s);
if (vocale( s[i-1])) return 1; 
else return 0;}

int vocale(char c);
/*postc: restituisce 1 se il carattere in input e' una vocale, 0 altrimenti */

int vocale(char c) {
	switch (c) {
		case ('a'):
		case ('e'):
		case ('i'):
		case ('o'):
		case ('u'):
		case ('A'):
		case ('E'):
		case ('I'):
		case ('O'):
		case ('U'):
			return 1;
		default:
			return 0;
	}
}

